import * as path from "path";
import { createRuntimeExportsUtils } from "@modern-js/utils";
var expressPlugin = function() {
  return {
    name: "@modern-js/plugin-express",
    setup: function(api) {
      var bffExportsUtils;
      var useAppContext = api.useAppContext;
      var runtimeModulePath = path.resolve(__dirname, "../runtime");
      return {
        config: function config() {
          var appContext = useAppContext();
          bffExportsUtils = createRuntimeExportsUtils(appContext.internalDirectory, "server");
          var runtimePath = process.env.NODE_ENV === "development" ? require.resolve("@modern-js/plugin-express/runtime") : "@modern-js/plugin-express/runtime";
          return {
            source: {
              alias: {
                "@modern-js/runtime/server": runtimePath,
                "@modern-js/runtime/express": runtimePath
              }
            }
          };
        },
        collectServerPlugins: function collectServerPlugins(param) {
          var plugins = param.plugins;
          plugins.push({
            "@modern-js/plugin-express": "@modern-js/plugin-express/server"
          });
          return {
            plugins
          };
        },
        addRuntimeExports: function addRuntimeExports(input) {
          var currentFile = bffExportsUtils.getPath();
          var relativeRuntimeModulePath = path.relative(path.dirname(currentFile), runtimeModulePath);
          var relativeFramePath = path.relative(path.dirname(currentFile), require.resolve("express"));
          bffExportsUtils.addExport("const pluginRuntime = require('".concat(relativeRuntimeModulePath, "');\n           const express = require('").concat(relativeFramePath, "')\n           module.exports = {\n            express: express,\n             ...pluginRuntime\n           }\n          "));
          return input;
        }
      };
    }
  };
};
var cli_default = expressPlugin;
export {
  cli_default as default,
  expressPlugin
};
