import "reflect-metadata";
import { createRouteHandler } from "./utils";
var registerRoutes = function(app, handlerInfos) {
  handlerInfos.forEach(function(param) {
    var routePath = param.routePath, handler = param.handler, httpMethod = param.httpMethod;
    var routeHandler = createRouteHandler(handler);
    var method = httpMethod.toLowerCase();
    var routeMiddlwares = Reflect.getMetadata("middleware", handler) || [];
    if (routeMiddlwares.length > 0) {
      app[method](routePath, routeMiddlwares, routeHandler);
    } else {
      app[method](routePath, routeHandler);
    }
  });
};
var registerRoutes_default = registerRoutes;
export {
  registerRoutes_default as default
};
