import { _ as _async_to_generator } from "@swc/helpers/_/_async_to_generator";
import { _ as _ts_generator } from "@swc/helpers/_/_ts_generator";
import { useContext } from "../context";
var Pipe = function(func) {
  return {
    name: "pipe",
    execute: (
      // eslint-disable-next-line consistent-return
      function execute(executeHelper, next) {
        return _async_to_generator(function() {
          var inputs, ctx, res, isPiped, end, output;
          return _ts_generator(this, function(_state) {
            switch (_state.label) {
              case 0:
                inputs = executeHelper.inputs;
                ctx = useContext();
                res = ctx.res;
                if (!(typeof func === "function"))
                  return [
                    3,
                    3
                  ];
                isPiped = true;
                end = function(value) {
                  isPiped = false;
                  if (typeof value === "function") {
                    value(res);
                    return;
                  }
                  return value;
                };
                return [
                  4,
                  func(inputs, end)
                ];
              case 1:
                output = _state.sent();
                if (!isPiped) {
                  if (output) {
                    return [
                      2,
                      executeHelper.result = output
                    ];
                  } else {
                    return [
                      2
                    ];
                  }
                }
                executeHelper.inputs = output;
                return [
                  4,
                  next()
                ];
              case 2:
                _state.sent();
                _state.label = 3;
              case 3:
                return [
                  2
                ];
            }
          });
        })();
      }
    )
  };
};
var Middleware = function(middleware) {
  return {
    name: "middleware",
    metadata: function metadata(helper) {
      var middlewares = helper.getMetadata("pipe") || [];
      middlewares.push(middleware);
      helper.setMetadata("middleware", middlewares);
    }
  };
};
export {
  Middleware,
  Pipe
};
